 
<img src="https://raw.githubusercontent.com/altar31/altar31/5fcce3a8ff99ecd838720bc4d43a22b1e5e37c9d/public/logo-magicml.png" alt="Image Title" width="800" height="auto">

## ☕️ About
**MagicML** is an open source **software** with a **Graphical User Interface (GUI)** to simplify Machine Learning (ML) models usage following the [MLOps](https://neptune.ai/blog/mlops) paradigm. It provides a **collection** of (scientific) **machine learning algorithms** and the necessary tooling for **model management**. 

 
<img src="https://raw.githubusercontent.com/altar31/altar31/5fcce3a8ff99ecd838720bc4d43a22b1e5e37c9d/public/magilml-mlops.png" alt="Image Title" width="800" height="auto">

**MagicML** take some inspiration from the [Weka](https://www.cs.waikato.ac.nz/ml/weka/index.html) software but in a lightweight manner, leverage the python ML ecosystem, the modern web stack (python [Dash](https://dash.plotly.com/)) and try to follow the [MLOps](https://en.wikipedia.org/wiki/MLOps) guidelines.
## 🎯 Goals

- Make ML algorithms more **acessible**
- Create an **open source** ML **workbench** for researchers and enginners


## 🚀 Features
- **Model architecture** -> model manager for using  pre-implemented models and allow the user to add this owns. In addition, by supporting the [Open Neural Network Exchange format (ONNX)](https://onnx.ai/), MagicML is framework **agnostic**.
- **Model training** -> train from scratch the model using the built-in tooling. In addition pre-trained models could also be used for specific tasks.
- **Model evaluation** -> for a selected model, the corresponding State Of The Art (SOTA) metrics are provided in order to assess the model performances. 
- **Model versioning** -> a tool for versioning ML training runs and experiments 
- **Model deployment** -> utilities for model deployment in production
- **Summary** -> automatic ML experiments reports after each run
- Stand on the **shoulders of giants** -> **MagicML** is built on top of [Dash](https://dash.plotly.com/), [Pandas](https://pandas.pydata.org/), [Keras](https://keras.io/), [scikit-learn](https://scikit-learn.org/stable/), [mlflow](https://mlflow.org/), and [seaborn](https://seaborn.pydata.org/). 

## ⚠️ Warnings
**For the moment:**
- The development of the project takes place in a **private** GitHub repository
- The project is at a very **early stage** -> **Nothing** is implemented in this **published version**
- The **documentation** is **missing**

The **GitHub repository** as well as a **usable** Python package will be **available** in the **upcoming months** when the project will be **more advanced**.


## 🤝 Community-driven
**MagicML** is foremost a **community-driven** project ! The project will be **highly collaborative** and everyone is welcome to the project ! 🤗 

Don't hesitate to contact me if you want to know more or are interested in ! 😃 

**Stay tuned !** 🗓️
 
